UNIT SPECTRO;


INTERFACE

Uses
  AonVars, vga256gr, fft_unit, crt, dos;

VAR
  {   ୠ }
  LogString: string;

Procedure PCM_FFT_Analiser(Var sPCM_buf: array of byte);

IMPLEMENTATION

Const
  c1: string[6] = 'F0F1';
  c2: string[6] = 'F0F2';
  c3: string[6] = 'F1F2';
  c4: string[6] = 'F0F4';
  c5: string[6] = 'F1F4';
  c6: string[6] = 'F2F4';
  c7: string[6] = 'F0F7';
  c8: string[6] = 'F1F7';
  c9: string[6] = 'F2F7';
  c0: string[6] = 'F4F7';
 c11: string[6] = 'F0F11';
 c12: string[6] = 'F1F11';
 c13: string[6] = 'F2F11';
 c14: string[6] = 'F4F11';
 c15: string[6] = 'F7F11';
_spaces: string[40] = '                                   ';

VAR
  { ६  FFT_UNIT }
  B,C:TComplexArray;
  I,J,K:Integer;

VAR
  { ᨢ  FFT - ३,  $80  2048 }
  {
  PCMframe: array[0..2048] of byte;
  }
  { ୠ }
  logf: text;
  { ᠫ ptr,   PCMframe  }
  p,vi: word;
  { ⭠  ᪮஢ ३ }
  num: string;
  digits: array[0..10] of string;
  { 砫 뫪, ᬥ饭  0 ஢ }
  ZeroOfs,DcOfs: word;


Function Int2Str(L : LongInt) : string;
{ Converts an integer to a string for use with OutText, OutTextXY }
var
  S : string;
begin
  Str(L, S);
  Int2Str := S;
end; { Int2Str }



Function CurrentDateTime: string;
Const
  Month : array[1..12] of string[9] =
  ('January','February','March','April','May','Juni','July','August',
   'September','October','November','December');
  WeekDay : array[0..6] of string[9] = ('Sunday','Monday','Tuesday','Wednesday',
   'Thursday','Friday','Saturday');
  RMonth : array[1..12] of string[8] =
  ('','ࠫ','','५','','','','',
   '','','','');
  RWeekDay : array[0..6] of string[11] = ('ᥭ','쭨',
  '୨','।','⢥','⭨','㡡');
var
  hour,minut,sec,sec100:word;
  hours,mins,secs:string;
  y, m, d, dow : Word;

begin
  gettime(hour,minut,sec,sec100); {砥 ⥬ ६}
  hours := int2str(hour)+':';
  mins := int2str(minut)+':';
  secs := int2str(sec);
  if  hour < 10 then hours := '0' + hours;
  if minut < 10 then  mins := '0' + mins;
  if   sec < 10 then  secs := '0' + secs;
  GetDate(y,m,d,dow); {砥 ⥬ }
  CurrentDateTime:=hours+mins+secs+'     '+
  rweekday[dow]+' '+Int2Str(d)+' '+ rmonth[m]+' '+Int2Str(y);
end;

Procedure PutPixel (X1, Y1: Integer; Color: Byte); assembler;
asm
  les  di, ActBlPtr
  mov  ax, Y1
  mov  bx, ActBX
  mul  bx
  add  ax, X1
  add  di, ax
  mov  al, Color
  stosb
end;


procedure SetPalette;
function F(X:Real):Integer;
begin
  F:=Round((1-Exp(-X))*63);
end;
var i:integer;
begin
  Port[$3C8]:=0;

  Port[$3C9]:=0;
  Port[$3C9]:=0;
  Port[$3C9]:=0;

  for I:=1 to 255 do begin
    Port[$3C9]:=F(I/16);
    Port[$3C9]:=(F(I/4)-F(I/16))*2;
    Port[$3C9]:=0;
  end;
end;


Procedure RulerBar;
var x,y,c: integer;

begin
   x:=0; y:=198;
   repeat
     Line(x,y,x,y-5,10);
     Line(x+5,y,x+5,y-2,10);
     Line(x+10,y,x+10,y-5,10);
     inc(x,10);
   until x=310;
   Line(0,y,0,y-8,40);
   Line(100,y,100,y-8,40);
   Line(200,y,200,y-8,40);
   Line(300,y,300,y-8,40);

end;




Procedure DecodeFrame;
var FrAver: word;                { । . ࣨ  ᯥ }
    FrSum: word;
    fi: word;
    max1,max2,max: word;         { ࣨ }
    max1i,max2i,maxi: word;      {   ᯥ }
    a1,a2,b1,b2,c1,c2,d1,d2,e1,e2,f1,f2: word;


begin
  FrSum:=0;
  for fi:=0 to 319 do begin
    FrSum:=FrSum+B[fi+FrameZero].Re;
  end;
  FrAver:=Round(FrSum/320);

  max1:=0;
  for fi:=0 to 319 do begin
    if B[fi+FrameZero].Re>max1 then begin
      max1:=B[fi+FrameZero].Re;
      max1i:=fi;
    end;
  end;

  max2:=0;
  for fi:=0 to 319 do begin
    if (B[fi+FrameZero].Re>max2) AND ((fi<(max1i-30)) OR (fi>(max1i+30)))
    then begin
      max2:=B[fi+FrameZero].Re;
      max2i:=fi;
    end;
  end;

  If max1i>max2i then begin
    maxi:=max1i;
    max1i:=max2i;
    max2i:=maxi;

    max:=max1;
    max1:=max2;
    max2:=max;

  end;

  num:='';

  a1:= F_700 - F_Delta; a2:= F_700 + F_Delta;
  b1:= F_900 - F_Delta; b2:= F_900 + F_Delta;
  c1:=F_1100 - F_Delta; c2:=F_1100 + F_Delta;
  d1:=F_1300 - F_Delta; d2:=F_1300 + F_Delta;
  e1:=F_1500 - F_Delta; e2:=F_1500 + F_Delta;
  f1:=F_1700 - F_Delta; f2:=F_1700 + F_Delta;

(*
  case max1i of
  {
     76..84: num:=num+'F0';
   114..122: num:=num+'F1';
   150..158: num:=num+'F2';
   188..196: num:=num+'F4';
   226..234: num:=num+'F7';
   263..271: num:=num+'F11';
  }
     a1..a2: num:=num+'F0';
     b1..b2: num:=num+'F1';
     c1..c2: num:=num+'F2';
     d1..d2: num:=num+'F4';
     e1..e2: num:=num+'F7';
     f1..f2: num:=num+'F11';
  end;

  case max2i of
   {
      76..84: num:=num+'F0';
    114..122: num:=num+'F1';
    150..158: num:=num+'F2';
    188..196: num:=num+'F4';
    226..234: num:=num+'F7';
    263..271: num:=num+'F11';
   }
     a1..a2: num:=num+'F0';
     b1..b2: num:=num+'F1';
     c1..c2: num:=num+'F2';
     d1..d2: num:=num+'F4';
     e1..e2: num:=num+'F7';
     f1..f2: num:=num+'F11';
  end;
*)
  If (max1i>=a1) AND (max1i<=a2) Then num:=num+'F0';
  If (max1i>=b1) AND (max1i<=b2) Then num:=num+'F1';
  If (max1i>=c1) AND (max1i<=c2) Then num:=num+'F2';
  If (max1i>=d1) AND (max1i<=d2) Then num:=num+'F4';
  If (max1i>=e1) AND (max1i<=e2) Then num:=num+'F7';
  If (max1i>=f1) AND (max1i<=f2) Then num:=num+'F11';

  If (max2i>=a1) AND (max2i<=a2) Then num:=num+'F0';
  If (max2i>=b1) AND (max2i<=b2) Then num:=num+'F1';
  If (max2i>=c1) AND (max2i<=c2) Then num:=num+'F2';
  If (max2i>=d1) AND (max2i<=d2) Then num:=num+'F4';
  If (max2i>=e1) AND (max2i<=e2) Then num:=num+'F7';
  If (max2i>=f1) AND (max2i<=f2) Then num:=num+'F11';

  If FFT_Graph_Monitor=1 Then Begin
  GotoXY(1,1);
  WriteLn(FrAver,'  ',max1i,' ',max1,'  ',max2i,' ',max2,'  ',ZeroOfs,'    ');
  End;
end;


Function TraceString(ts: string): string;

Var pos13_1,pos13_2: word;
    temp_ts: string;

Begin
  temp_ts:=ts;

  pos13_1:=Pos('|',temp_ts);

  If pos13_1<>0 Then Begin  {  ᫨   _13_  }
    Delete(temp_ts,1,pos13_1);
    pos13_2:=Pos('|',temp_ts);

    If pos13_2<>0 Then Begin  {  ᫨   _13_  }
      Delete(temp_ts,pos13_2,Length(temp_ts)-pos13_2+1);
      Insert(' : ',temp_ts,Length(temp_ts));
    End
    Else Begin  {  ᫨  ன _13_  }
    {-             ᭮ ਠ     -}
      temp_ts:=ts;
      { ᫨   8  }
      If Length(ts)-pos13_1=8 Then
        temp_ts:=Copy(ts,pos13_1+1,7)+' : '+Copy(ts,pos13_1+8,1);
      { ᫨ ﭠ  ⥣ਨ }
      If Length(ts)-pos13_1=7 Then
        temp_ts:=Copy(ts,pos13_1+1,7)+' : '+Copy(ts,pos13_1-1,1);
      { ᫨ ᫥ 1- _13_   7 }
      If Length(ts)-pos13_1<7 Then Begin
        temp_ts:=Copy(ts,pos13_1+1,Length(ts)-pos13_1)+'^';
        temp_ts:=temp_ts+
          Copy(ts,pos13_1-(8-(Length(ts)-pos13_1)),8-(Length(ts)-pos13_1));
        Insert(' : ',temp_ts,Length(temp_ts));

      End;
    End;

  End
  Else Begin  {  ᫨    _13_  }
    temp_ts:=ts;

  End;

  TraceString:=' : '+temp_ts;
End;


Function VolumeNormalize(var wavbuf: array of byte): boolean;
Var i: word;
    Sample: integer;
    Max,Min: integer;
    Average: longint;
    MaxAmpl: word;
    Factor: word;
Begin
  VolumeNormalize:=False;
  { 室 ।  ᨬ  }
  Max:=0;
  Min:=0;
  Average:=0;
  For i:=0 to Round(ReceiveBytes*3.06)-1 do begin
     Case wavbuf[i] of
         0..127: Sample:=-(128-wavbuf[i]);
       128..255: Sample:=wavbuf[i]-128;
     End;
     If Sample>Max Then Max:=Sample;
     If Sample<Min Then Min:=Sample;
     Average:=Average+ABS(Sample);

  End;
  {- -}
  Average:=Round(Average/Round(ReceiveBytes*3.06));
  {- -}
  MaxAmpl:=Max+ABS(Min);
  {- -}
  If MaxAmpl<>0 Then Factor:=Round(128/(MaxAmpl/2)) Else Factor:=1;

  { ᫨ । 祭   祬 室 }
  If (Average<VolumeCorrection) AND (Factor<>1) Then Begin
    VolumeNormalize:=True;

    For i:=0 to Round(ReceiveBytes*3.06)-1 do begin
       Case wavbuf[i] of
           0..127: Sample:=-(128-wavbuf[i]);
         128..255: Sample:=wavbuf[i]-128;
       End;
       Sample:=Sample * Factor;
       If Sample>127 Then Sample:=127;
       If Sample<-128 Then Sample:=-128;

       wavbuf[i]:=128+Sample;

    End;
  End;
  {
  writeln(average,'  ',maxampl,'  ',i,'  ',VolumeCorrection,'  ',max,'  ',min);
  readln;
  }
End;



Function DualToneOffset(Var buff:array of byte): Word;

Function DualToneFinder: word;
var FrAver: word;        { । . ࣨ  ᯥ }
    FrSum: word;
    fri: word;
    f1,f2,f3,f4,f5,f6: word;
    mf1,mf2,mf3,mf4,mf5,mf6: word;
    mfx: word;

begin


  f1:= F_700 - F_Delta; mf1:=0;
  f2:= F_900 - F_Delta; mf2:=0;
  f3:=F_1100 - F_Delta; mf3:=0;
  f4:=F_1300 - F_Delta; mf4:=0;
  f5:=F_1500 - F_Delta; mf5:=0;
  f6:=F_1700 - F_Delta; mf6:=0;


  FrSum:=0;
  for fri:=0 to F_Delta*2-1 do begin

    FrSum:=FrSum + B[f1+fri+FrameZero].Re+
                   B[f2+fri+FrameZero].Re+
                   B[f3+fri+FrameZero].Re+
                   B[f4+fri+FrameZero].Re+
                   B[f5+fri+FrameZero].Re+
                   B[f6+fri+FrameZero].Re;

    if B[f1+fri+FrameZero].Re>mf1 Then mf1:=B[f1+fri+FrameZero].Re;
    if B[f2+fri+FrameZero].Re>mf2 Then mf2:=B[f2+fri+FrameZero].Re;
    if B[f3+fri+FrameZero].Re>mf3 Then mf3:=B[f3+fri+FrameZero].Re;
    if B[f4+fri+FrameZero].Re>mf4 Then mf4:=B[f4+fri+FrameZero].Re;
    if B[f5+fri+FrameZero].Re>mf5 Then mf5:=B[f5+fri+FrameZero].Re;
    if B[f6+fri+FrameZero].Re>mf6 Then mf6:=B[f6+fri+FrameZero].Re;

  end;

  FrAver:=Round(FrSum/(F_Delta*12));
  {
  FrAver:=Round((mf1+mf2+mf3+mf4+mf5+mf6)/6);
  }

  mfx:=0;
  If mf1>{=}FrAver Then Inc(mfx);
  If mf2>FrAver Then Inc(mfx);
  If mf3>FrAver Then Inc(mfx);
  If mf4>FrAver Then Inc(mfx);
  If mf5>FrAver Then Inc(mfx);
  If mf6>FrAver Then Inc(mfx);
  DualToneFinder:=mfx;

end;


var
  DualToneOffs: word;
  PeakCount: word;

Begin

  DualToneOffs:=0;

  Repeat

    {  ᨢ PCMframe }
    for vi:=ZeroOfs+DualToneOffs to ZeroOfs+DualToneOffs+FrameSize do
      B[vi-DualToneOffs-ZeroOfs].Re:=buff[vi{-ZeroOfs}]-128;
    for vi:=FrameSize+1 to 2047 do B[vi].Re:=0;

    FFTEnergy(B);
    {  ⠡ }
    for I:=0 to N div 2-1 do begin
      B[I].Re:=Round(Sqrt(Word(B[I].Re)));
      if B[I].Re>127 then B[I].Re:=127;
      if B[I].Re<2 then B[I].Re:=0;
    end;

    PeakCount:=DualToneFinder;
    If (PeakCount>2) OR (PeakCount<2) Then Inc(DualToneOffs,DTFinderStep);
                                                            {===}

  Until (PeakCount=2) Or (DualToneOffs>DTFinderSamples);

  If DualToneOffs>DTFinderSamples Then DualToneOffset:=0
    Else DualToneOffset:=DualToneOffs;


End;



Procedure PCM_FFT_Analiser(Var sPCM_buf: array of byte);

begin
  DirectVideo:=False;

  { ᫨ ࠧ襭 뢮 䨪 }
  IF FFT_Graph_Monitor=1 THEN BEGIN
    IF NOT InitGraph THEN HALT(0);
    SetPalette;
    RulerBar;
  END;

  { ४ ஢ ᨣ }
  If VolumeCorrection<>0 Then VolumeNormalize(sPCM_buf);

  { 室  室  }
  ZeroOfs:=0;
  DcOfs:=128;

  IF SearchForPacketOffset=1 Then Begin
    repeat
      DcOfs:=sPCM_buf[ZeroOfs];
      inc(ZeroOfs);
    until (DcOfs>144) OR (ZeroOfs>400);
  End;

  ZeroOfs:=ZeroOfs+DualToneOffset(sPCM_buf);










  p:=0;
  num:='';

  repeat
    {  ᨢ PCMframe }
    {
    for vi:=0 to FrameSize do PCMframe[vi]:=sPCM_buf[ZeroOfs+p*FrameSize+vi];
    for vi:=FrameSize+1 to 2048 do PCMframe[vi]:=128;
    }
    for vi:=0 to FrameSize do
      B[vi].Re:=sPCM_buf[ZeroOfs+p*FrameSize+vi]-128;
    for vi:=FrameSize+1 to 2047 do B[vi].Re:=0;


    { ஥ ८ࠧ    ᨢ PCMframe }
    (*
    for I:=0 to N-1 do begin

      B[I].Re:=PCMframe[I]-128;
      B[I].IM:=PCMframe[I]-128;
      {
      B[I].Re:=PCMframe[I];
      B[I].IM:=PCMframe[I];
      }
    end;
    *)
    FFTEnergy(B);
    {  ⠡ }
    for I:=0 to N div 2-1 do begin
      B[I].Re:=Round(Sqrt(Word(B[I].Re)));
      B[I].IM:=Round(Sqrt(Word(B[I].IM)));
      if B[I].Re>127 then B[I].Re:=127;
      if B[I].IM>127 then B[I].IM:=127;
      if B[I].Re<2 then B[I].Re:=0;
      if B[I].IM<2 then B[I].IM:=0;
    end;

    {   320x200 }
    { ᫨ ࠧ襭 뢮 䨪 }
    IF FFT_Graph_Monitor=1 THEN BEGIN
      for I:=0 to 319 do begin
        for k:=190 downto 70 do PutPixel(i,k,0);
        for k:=0 to B[I+FrameZero].Re do PutPixel(i,180-k,k+1);
      end;
    END;
    { ᪠ }
    If DebugMode=1 Then Begin
      {Vertical}
      Line( 80,190, 80,40,15);
      Line(118,190,118,40,15);
      Line(154,190,154,40,15);
      Line(192,190,192,40,15);
      Line(230,190,230,40,15);
      Line(267,190,267,40,15);
      {Horizontal}
      Line( 80,50,118,50,15);  {F0F1}
      Line( 80,54,154,54,25);  {F0F2}
      Line(118,58,154,58,15);  {F1F2}
      Line( 80,62,192,62,25);  {F0F4}
      Line(118,66,192,66,15);  {F1F4}
      Line(154,70,192,70,25);  {F2F4}
      Line( 80,74,230,74,15);  {F0F7}
      Line(118,78,230,78,25);  {F1F7}
      Line(154,82,230,82,15);  {F2F7}
      Line(192,86,230,86,25);  {F4F7}
      Line(154,90,267,90,15);  {F2F11}
      Line(192,94,267,94,25);  {F4F11}


    End;


    DecodeFrame;
    digits[p]:=num;

    inc(p);

    IF DebugMode=1 THEN ReadKey;

  until p=DecodeFrames;


  IF FFT_Graph_Monitor=1 THEN CloseGraph;

  num:='';
  p:=0;

  Repeat
         IF digits[p]=c1  then num:='1'+num
    Else If digits[p]=c2  then num:='2'+num
    Else If digits[p]=c3  then num:='3'+num
    Else If digits[p]=c4  then num:='4'+num
    Else If digits[p]=c5  then num:='5'+num
    Else If digits[p]=c6  then num:='6'+num
    Else If digits[p]=c7  then num:='7'+num
    Else If digits[p]=c8  then num:='8'+num
    Else If digits[p]=c9  then num:='9'+num
    Else If digits[p]=c0  then num:='0'+num
    Else If digits[p]=c11 then num:='_'+num
    Else If digits[p]=c12 then num:='_'+num
    Else If digits[p]=c13 then num:='|'+num
    Else If digits[p]=c14 then num:='r'+num
    Else If digits[p]=c15 then num:='_'+num
    Else num:='?'+num;
    inc(p);
  Until p=DecodeFrames;

  Repeat
    p:=pos('r',num);
    if p<>0 then begin
      delete(num,p,1);
      insert(copy(num,p-1,1),num,p);
    end;
  Until p=0;

  num:=TraceString(num);

  If TerminalEcho=1 Then WriteLn(num);

  If ParamCount=0 Then Begin
    {$I-}
    Assign(logf,PathToAon_Exe+LogFile);
    Append(logf);
    If IOResult<>0 Then ReWrite(logf);

    LogString:=num+Copy(_spaces,1,30-length(num))+CurrentDateTime;

    WriteLn(logf,LogString);
    Close(logf);
  End;

End;

BEGIN

END.
